## 3̓XNvg
### mF
## R 2.15.2
## package mirt 0.5.0

library(mirt)

##########################################
## ړȐ`֐iړxlD=1.0j
# mirt::coef()ɂĎZoIRTꐔ̃IuWFNg
# number = ڔԍ
# degree = }̊pxCȗ45
# D = ړxqCȗ1.702
# main = }̖́Bȗ Item + ڂ̏ ƂȂB

# ⏞^fpIRS
irs<-function(coef,number,degree=45,D=1.702,gue=g,upp=u,main=paste("Item",number,sep="")){
	x <- seq(-4, 4, length= 100); y <- x
	par(oma = c(0, 0, 1, 0),mar=c(0,2,1,0))
	a1 <- coef[[number]][1,1]
	a2 <- coef[[number]][1,2]
	d  <- coef[[number]][1,3]
	g  <- coef[[number]][1,4]
	u  <- coef[[number]][1,5]
	f <- function(x,y) { p <- g+(u-g) * (1/(1+(exp(-D*((a1)*x + (a2)*y + d)))))}
	z <- outer(x, y, f);
	persp(x, y, z, theta = degree, phi = 30, expand = 0.6, zlim=c(0,1), 
	      main=main, xlab="1", ylab="2", zlab="p(u=1)",ticktype="detailed")
}

## I⏞fpIRS֐
# mirt::coef()IuWFNgƍڔԍn
# degreeŉ
irspc<-function(coef,number,degree=45,D=1.702,main=paste("Item",number,sep="")){
	x <- seq(-4, 4, length= 100); y <- x
	par(oma = c(0, 0, 1, 0),mar=c(0,2,1,0))
	a1 <- coef[[number]][1,1]
	a2 <- coef[[number]][1,2]
	d1 <- coef[[number]][1,3]
	d2 <- coef[[number]][1,4]
	g  <- coef[[number]][1,5]
	u  <- coef[[number]][1,6]
	f <- function(x,y) { 
		p <- g+(u-g) * (1/(1+(exp(-D*(a1*x + d1)))) * 1/(1+(exp(-D*(a2*y + d2)))))
	}
	z <- outer(x, y, f);
	persp(x, y, z, theta = degree, phi = 30, expand = 0.6, zlim=c(0,1), #shade=0.1,
	      main=main, xlab="1", ylab="2", zlab="p(u=1)",ticktype="detailed")
}

# TIfpIRS
irsexp<-function(coef,number,degree=45,D=1.702,gue=g,upp=u){
	x <- seq(-4, 4, length= 100); y <- x
	par(oma = c(0, 1, 1, 0))
	a1 <- coef[[number]][1]
	a2 <- coef[[number]][2]
	d  <- coef[[number]][3]
	g  <- coef[[number]][4]
	u  <- coef[[number]][5]
	f <- function(x,y) { p <- g+(u-g) * (1/(1+(exp(-D*((a1)*x + (a2)*y + d)))))}
	z <- outer(x, y, f);
	persp(x, y, z, theta = degree, phi = 30, expand = 0.6, zlim=c(0,1), 
	      main=paste("Item",number,sep=""), xlab="1", ylab="2", zlab="p(u=1)",ticktype="detailed")
}



##########################################
## f[^̏
##########################################
# uNAEPf[^v̓ǂݍ
naep <- read.csv("naep.csv",header=T)
head(naep)

#uIQeXgf[^v̓ǂݍ
iqtf <- read.csv("iqtf.csv",header=T)
head(iqtf)

##########################################
## ͗
##########################################
## 2lf[^̕⏞Ifɂ镪
# confmirt.model()ɂ郂f̋Lq
#  = ڂ̌`ŋLqDڂ̓J}ŋ؂D
# ڂAĔzĂꍇ̓nCtŌqƂ\D
# Ⴆ΍1獀5܂ł̏ꍇCu1,2,3,4,5vƂu1-5vƂLq\D

# confmirt()ɂĕꐔsD
# 
# model = fLqIuWFNg
# data = f[^̎w
# pars = ڕꐔ̊mFCۂD
# D = ړxqDftHgł1.702ƂȂD

## ꐔ̐
# pars="values"Ƃ邱ƂŁCڕꐔ̈ꗗD
# ŁCႦ΍12ڂ̎ʗ͂0ɌŒ肵ꍇCڕꐔ̈ꗗ̃IuWFNgɊւāCꐔ̔ԍ"parnum"ƁC肷邩ۂ"est"mFC
# mod2[2,5] <- 0; mod2[2,6] <- FALSE;
# ̂悤Ɏw肷D͒l[ƂCsȂCŒ肷Ƃw\ĂD
# ꐔ̐wɂ́C߂Ċ֐confmirt()sD̍ۈ"pars"ɂ͕ꐔۂԂ̍ڕꐔꗗIuWFNgw肷邱Ƃɒӂ邱ƁD

modelnaep <- confmirt.model()
f1 = 1-8
f2 = 1-8

mod2 <- confmirt(data=naep,model=modelnaep, pars="values", D=1.702)
fitnaep <- confmirt(data=naep, model=modelnaep, pars=mod2, D=1.702)
fitnaep #KxwWi\3.6j

# qחʂ̏o
summary(fitnaep) #\3.3
# ֐coef()ɂIRTꐔo͂D
coef(fitnaep) #\3.4

naepcoefmat <- t(as.data.frame(coef(fitnaep)[1:8]))
# ʗ
MAnaep_comp <- sqrt(rowSums(cbind(naepcoefmat[seq(1,40,5),1],naepcoefmat[seq(2,40,5),1])^2))
# 3ɂĂ̑ʗ͂̌Z
round(sqrt(0.446^2 + 0.474^2),3)

# x
MDnaep_comp <- -naepcoefmat[seq(3,40,by=5),1]/MAnaep_comp
# 3ɂĂ̑x̌Z
round(-0.347/.651,3)
#Sڂ̑ʗ͂Ƒxi\3.4j
round(cbind(MAnaep_comp,MDnaep_comp),3)

# alpha̎Zo #
library(aspace)
MDISC<-c(0.651,0.521,0.552,1.016,0.980,0.788,0.729,0.536)
a1<-c(0.446 ,0.189 ,0.511 ,0.750 ,0.758 ,0.451 ,0.665 ,0.476)
a2<-c(0.474, 0.486, 0.208, 0.686, 0.621, 0.646, 0.298, 0.246)
cbind(round(acos_d(a1/MDISC)),
round(acos_d(a2/MDISC)))

# ⏞^f IRS̕`(ڔԍƏԂ̈Ⴂɒ)
naepcoef<-coef(fitnaep)
irs(naepcoef,1, degree=315, main="Item3") #Item3
irs(naepcoef,2, degree=315, main="Item5") #Item5
irs(naepcoef,3, degree=315, main="Item7") #Item7
irs(naepcoef,4, degree=315, main="Item8") #Item8
irs(naepcoef,5, degree=315, main="Item9") #Item9
irs(naepcoef,6, degree=315, main="Item10") #Item10
irs(naepcoef,7, degree=315, main="Item11") #Item11
irs(naepcoef,8, degree=315, main="Item12") #Item12

# IRS͊֐ itemplot()pĕ`悷邱Ƃ\
# 1IRS`悷
itemplot(fitnaep,1)


##########################################
## I⏞^fi⏞^fj

# ⏞^fsɂ́C֐ confmirt()̈ itemtypeɁC"PC2PL"w肷

partdat <- naep
partnaep <- confmirt.model()
f1 = 1-8
f2 = 1-8

partmod <- confmirt(data=partdat,model=partnaep,pars="values",itemtype="PC2PL",D=1.702)
fitpart <- confmirt(data=partdat,model=partnaep,itemtype="PC2PL",pars=partmod,D=1.702)
fitpart #KxwWi\3.6j
summary(fitpart)#\3.5qח
t(as.data.frame(coef(fitpart))) #\3.5ڕꐔ

# ⏞^f IRS̕`
fitpartcoef<-coef(fitpart)
irspc(fitpartcoef,1, degree=315, main="Item3") #Item3
irspc(fitpartcoef,2, degree=315, main="Item5") #Item5
irspc(fitpartcoef,3, degree=315, main="Item7") #Item7
irspc(fitpartcoef,4, degree=315, main="Item8") #Item8
irspc(fitpartcoef,5, degree=315, main="Item9") #Item9
irspc(fitpartcoef,6, degree=315, main="Item10") #Item10
irspc(fitpartcoef,7, degree=315, main="Item11") #Item11
irspc(fitpartcoef,8, degree=315, main="Item12") #Item12


##########################################
## TIڔfFuIQeXgf[^v̕
# "rotate"ňq̉]@w\łDftHgł"varimax"ƂȂD
# ̑"promax","biquartimin","geominT","geominQ"w\łD
# ڂ]@̖̎w@RpbP[W"GPArotation"̃}jAQƂihttp://cran.r-project.org/web/packages/GPArotation/index.htmljD

# TIf̏ꍇC"model"ɂ͎w肷D

iqtfmirt2 <- mirt(data=iqtf, model=2, rotate="varimax",itemtype="2PL",D=1.702)
summary(iqtfmirt2) #\3.10
t(as.data.frame(coef(iqtfmirt2)[1:16])) #ڕꐔi\3.9j

mdis<-t(as.data.frame(coef(iqtfmirt2)[1:16])) 
#MDISCMDIFFZoi\3.9j
round(cbind(sqrt(mdis[,1]^2 + mdis[,2]^2),-(mdis[,3])/(sqrt(mdis[,1]^2 + mdis[,2]^2))),3)

# IRS`
iqtfmirt2coef<-coef(iqtfmirt2)
#ႦΑ1ڂ̏ꍇ
irsexp(iqtfmirt2coef,1,D=1.702)

##########################################
## FIFAiS񍀖ڈq́jsBiuIQeXgf[^vgpj
iq4mod <- confmirt.model()
f1 = 1,2,3,4
f2 = 5,6,7,8
f3 = 9,10,11,12
f4 = 13,14,15,16

confmirtFitIQ1 <- confmirt(data=iqtf, model=iq4mod, D=1.702)
(confmirtFitIQ1) #KxwW
summary(confmirtFitIQ1) #\3.11


# qXRA̐
fscoreIQ1 <- mirt::fscores(confmirtFitIQ1, full.scores=T)#EAPl
nrow(fscoreIQ1)
length(which((duplicated(fscoreIQ1)==T)))
table(rowSums(iqtf))
table(round(fscoreIQ1[,17:20],3))
# 20̓_ƈqXRA擾
tscore <- rowSums(fscoreIQ1[1:20, 1:16])
cbind(fscoreIQ1[1:20, 1:16], tscore,round(fscoreIQ1[1:20, 17:20],3),
      rowMeans(round(fscoreIQ1[1:20, 17:20],3))) #\3.12

##########################################
## ʈq肵fioqfj
iq4mod_bifac <- confmirt.model()
f1 = 1,2,3,4
f2 = 5,6,7,8
f3 = 9,10,11,12
f4 = 13,14,15,16
G = 1-16

iq4mod_bifac.2 <- confmirt(data=iqtf, model=iq4mod_bifac, pars="values",D=1.702)
head(iq4mod_bifac.2)
confmirtFitIQ2 <- confmirt(data=iqtf, model=iq4mod_bifac, D=1.702)
confmirtFitIQ2 #KxwW
summary(confmirtFitIQ2) #\3.13

