#
# V́ubVfv
#


#
# ݃NX
#

# f[^̓ǂݍ
# Lc(2012)w̓eXg18
# 32,33,34,35,44,45,46,49
# e͕\7.4Q

dat <- read.csv("gaku1item8.csv", header=FALSE)

# pbP[W̓ǂݍ
library(poLCA)

# poLCA̎dlɂ0-1f[^1-2f[^ɕϊ
datPlus1 <- dat + 1
# ------ ɗ^`̏
varName <- paste("V", 1:8, sep="")
datName <- paste("datPlus1[, ", 1:8, "]", sep="")
formulaName <- paste(varName, datName, sep="=", collapse=",")
f <- paste("cbind(", formulaName, ") ~ 1")
# ------ `̏܂

# 13NXz肵݃NX
M1 <- poLCA(eval(parse(text=f)), nclass=1, data=dat, maxiter=5000, nrep=10, verbose=FALSE)
M2 <- poLCA(eval(parse(text=f)), nclass=2, data=dat, maxiter=5000, nrep=10, verbose=FALSE)
M3 <- poLCA(eval(parse(text=f)), nclass=3, data=dat, maxiter=5000, nrep=10, verbose=FALSE)

# ʋKi\7.5j̎擾
matrix(c(M1$aic, M2$aic, M3$aic, M1$bic, M2$bic, M3$bic), ncol=2, dimnames=list(c("G=1", "G=2", "G=3"),c("AIC", "BIC")))

# ݃NX1̏ꍇ8ڂ̐m
round(matrix(unlist(M1$probs),ncol=2,byrow=TRUE)[,2],3)

# ݃NX2̏ꍇ8ڂ̐m
round(matrix(unlist(M2$probs), ncol=4, byrow=TRUE)[,3:4],3)
# 䗦
round(M2$P,3)

# ݃NX3̏ꍇ8ڂ̐m
round(matrix(unlist(M3$probs), ncol=6, byrow=TRUE)[,4:6],3)
# 䗦
round(M3$P,3)

#
# bVf
#

# pbP[W̓ǂݍ
library(psychomix)
# _Ɩ_̔팱҂̏O
totalScores <- rowSums(dat)
datNo08 <- dat[(0 < totalScores & totalScores < ncol(dat)), ]
datNo08 <- as.matrix(datNo08)
# NX13܂őz肵2l^݃bVf̐
# ݓIv_zɂ͌Iȃfݒ
# o͂ƂďʋK\i\7.6j
set.seed(1234)
( gaku8MeanVar <- raschmix(data = datNo08, k = 1:3, scores = "meanvar" ) )

# BIC̒l݃NX2̗p
gaku8Class2 <- getModel(gaku8MeanVar, which = 2)
# ڍxvtB[i}7.2j
xyplot(gaku8Class2)
# v_z̕ꐔ
parameters(gaku8Class2, which = "score")
# v_zi\7.7j
round(scoreProbs(gaku8Class2),3)
# 䗦
round(gaku8Class2@size/gaku8Class2@nobs,3)

#
# ϗʕtbVf
#

# f[^̓ǂݍ݂Ɛ`
tmp <- read.csv("jugyoCov.csv",header=FALSE)
jugyoCov <- data.frame(x=tmp[,7])
jugyoCov$resp <- as.matrix(tmp[,1:6])

# ϗʂƂȂbVfɂ镪͂̎s
# ݓIv_zɂ͌Iȃfݒ
# o͂ƂďʋK\i\7.9j
set.seed(4321)
( jugyoMeanVarCov <- raschmix(resp ~ x, data = jugyoCov, k = 1:3, scores = "meanvar" ) )

# NX2̗p
jugyoClass2 <- getModel(jugyoMeanVarCov, which = 2)
# ڃvtB[i}7.3j
plot(jugyoClass2)
# ϗʂ̉e
parameters(jugyoClass2, which = "concomitant")

#
# lbVf
#

# pbP[W̓ǂݍ
library(mixRasch)

# f[^̓ǂݍ
jugyo3cat <- read.csv("jugyo3cat.csv", header=FALSE)

# ͂ƏʋK
# ̓_f
#isɍڕꐔ̐ɗpȂ_Ɩ_Ɋւxj

set.seed(2345)
MixPCM1 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=1, model="PCM")

MixPCM2 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=2, model="PCM")

MixPCM3 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=3, model="PCM")

MixPCM4 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=4, model="PCM")

# ʋK̎擾
matrix(c(
 MixPCM1$info.fit$AIC,
 MixPCM2$info.fit$AIC,
 MixPCM3$info.fit$AIC,
 MixPCM4$info.fit$AIC,
 MixPCM1$info.fit$BIC,
 MixPCM2$info.fit$BIC,
 MixPCM3$info.fit$BIC,
 MixPCM4$info.fit$BIC
), ncol=2, dimnames=list(c("G=1", "G=2", "G=3", "G=4"),c("AIC", "BIC")))

# ]ړxf
#isɍڕꐔ̐ɗpȂ_Ɩ_Ɋւxj
set.seed(5432)
MixRSM1 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=1, model="RSM")

MixRSM2 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=2, model="RSM")

MixRSM3 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=3, model="RSM")

MixRSM4 <- mixRasch(jugyo3cat, steps=2, max.iter=500, conv.crit=.0001, n.c=4, model="RSM")

# ʋK̎擾i\7.10j
matrix(c(
 MixRSM1$info.fit$AIC,
 MixRSM2$info.fit$AIC,
 MixRSM3$info.fit$AIC,
 MixRSM4$info.fit$AIC,
 MixRSM1$info.fit$BIC,
 MixRSM2$info.fit$BIC,
 MixRSM3$info.fit$BIC,
 MixRSM4$info.fit$BIC
), ncol=2, dimnames=list(c("G=1", "G=2", "G=3", "G=4"),c("AIC", "BIC")))


# NX2Ƃ]ړxf̍ڕꐔl
round(MixRSM2$LatentClass[[1]]$item.par$tau, 3)
round(MixRSM2$LatentClass[[2]]$item.par$tau, 3)
# \7.11
round(rbind(
 MixRSM2$LatentClass[[1]]$item.par$delta.i,
 MixRSM2$LatentClass[[2]]$item.par$delta.i
),3)


